<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Magento\Framework\App\ObjectManager;

/**
 * Class CriticalCommand
 * @package FiloBlu\Flow\Console\Command
 */
class CriticalCommand extends Command
{
    /**
     * @var \Magento\Framework\App\State
     */
    protected $_state;

    /**
     * FetchCommand constructor.
     * @param \Magento\Framework\App\State $state
     */
    public function __construct(\Magento\Framework\App\State $state)
    {
        $this->_state = $state;
        parent::__construct();
    }

    /**
     *
     */
    protected function configure()
    {
        $this->setName('flow:critical')
            ->setDescription('Process critical flows executing fetch receive parse and process in one shot');
    }

    /**
     * @param InputInterface $input
     * @param OutputInterface $output
     * @return int|null|void
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        try {
            $this->state->setAreaCode(\Magento\Framework\App\Area::AREA_ADMINHTML);
        } catch (\Exception $e) {
            $output->writeln("Areacode was already set, skipping!");
        }

        $cronModel = ObjectManager::getInstance()->create(\FiloBlu\Flow\Cron\Fetch::class);
        $cronModel->processCritical();

        $output->writeln('<info>Processed criticals !</info>');
    }

}